/* Register a C function so the script can call it */
FAWK_API int fawk_symtab_regcfunc(fawk_ctx_t *ctx, const char *name, fawk_cfunc_t cfunc);

/* Register a global variable; tclass is either FAWK_SCALAR or FAWK_ARRAY;
   when array, the array initialization is done and the cell is an empty
   array; when scalar, the cell is initialized to NIL */
FAWK_API fawk_cell_t *fawk_symtab_regvar(fawk_ctx_t *ctx, const char *name, fawk_celltype_t tclass);

/* Return the cell of a global variable by name or NULL if it doesn't exist */
FAWK_API fawk_cell_t *fawk_sym_lookup(fawk_ctx_t *ctx, const char *name);


/* Return the actual data cell of a symref; if the symref is an array, this
   is the cell within the array at the specific index. If arr_create is
   non-zero, array elements indexed are created. If parent is not NULL
   it is loaded with the innermost array hosting the cell (or NULL for vars).
   Note: it is really implemented in execute.c for inlining/performance */
FAWK_API fawk_cell_t *fawk_symtab_deref(fawk_ctx_t *ctx, const fawk_symref_t *sr, int arr_create, fawk_cell_t **parent);

/* Internal: register a new script function while parsing */
FAWK_API int fawk_symtab_regfunc(fawk_ctx_t *ctx, const char *name, size_t addr, int numargs, int numfixedargs);
